define(["require", "exports", 'react', 'react-dom', 'react-addons-test-utils', './Breadcrumb'], function (require, exports, React, ReactDOM, ReactTestUtils, Breadcrumb_1) {
    "use strict";
    var expect = chai.expect;
    describe('Breadcrumb', function () {
        it('can call the callback when an item is clicked', function () {
            var callbackValue;
            var clickCallback = function (key) {
                callbackValue = key;
            };
            var items = [
                { text: 'TestText', key: 'TestKey', onClick: clickCallback }
            ];
            var component = ReactTestUtils.renderIntoDocument(React.createElement(Breadcrumb_1.Breadcrumb, {items: items}));
            var renderedDOM = ReactDOM.findDOMNode(component);
            var itemLink = renderedDOM.querySelector('.ms-Breadcrumb-itemLink');
            ReactTestUtils.Simulate.click(itemLink);
            expect(callbackValue).to.equal('TestKey');
        });
    });
});
