import * as React from 'react';
import { ICommandBarProps } from './CommandBar.Props';
import { IContextualMenuItem } from '../../ContextualMenu';
import './CommandBar.scss';
export interface ICommandBarState {
    renderedItems?: IContextualMenuItem[];
    renderedOverflowItems?: IContextualMenuItem[];
    expandedMenuItemKey?: string;
    expandedMenuId?: string;
    contextualMenuItems?: IContextualMenuItem[];
    contextualMenuTarget?: HTMLElement;
    renderedFarItems?: IContextualMenuItem[];
}
export declare class CommandBar extends React.Component<ICommandBarProps, ICommandBarState> {
    static defaultProps: {
        items: any[];
        overflowItems: any[];
        farItems: any[];
    };
    refs: {
        [key: string]: React.ReactInstance;
        commandSurface: HTMLElement;
        farCommandSurface: HTMLElement;
        commandBarRegion: HTMLElement;
        searchSurface: HTMLElement;
    };
    private _instanceId;
    private _overflowWidth;
    private _commandItemWidths;
    private _events;
    constructor(props: ICommandBarProps);
    componentDidMount(): void;
    componentWillUnmount(): void;
    componentWillReceiveProps(nextProps: ICommandBarProps): void;
    componentDidUpdate(prevProps: ICommandBarProps, prevStates: ICommandBarState): void;
    render(): JSX.Element;
    private _renderItemInCommandBar(item, index, expandedMenuItemKey, isFarItem?);
    private _updateItemMeasurements();
    private _updateRenderedItems();
    private _onItemClick(item, ev);
    private _onOverflowClick(ev);
    private _onContextMenuDismiss(ev?);
    private _getStateFromProps(nextProps);
}
