import * as React from 'react';
import './Image.scss';
import { IImageProps } from './Image.Props';
export interface IImageState {
    loadState?: ImageLoadState;
}
export declare enum CoverStyle {
    landscape = 0,
    portrait = 1,
}
export declare const CoverStyleMap: {};
export declare const ImageFitMap: {};
export declare enum ImageLoadState {
    notLoaded = 0,
    loaded = 1,
    error = 2,
    errorLoaded = 3,
}
export declare class Image extends React.Component<IImageProps, IImageState> {
    static defaultProps: {
        shouldFadeIn: boolean;
    };
    refs: {
        [key: string]: React.ReactInstance;
        image: HTMLImageElement;
    };
    private _events;
    private _coverStyle;
    constructor(props: IImageProps);
    componentDidMount(): void;
    componentWillReceiveProps(nextProps: any): void;
    componentWillUnmount(): void;
    render(): JSX.Element;
    private _evaluateImage();
    private _computeCoverStyle();
    private _setError();
}
