import * as React from 'react';
export interface ILinkProps extends React.HTMLProps<HTMLLabelElement> {
    /**
     *  The props of pop up window.
     */
    popupWindowProps?: IPopupWindowProps;
}
export interface IPopupWindowProps {
    /**
     * Title of pop up window
     */
    title: string;
    /**
     * Width of pop up window
     */
    width: number;
    /**
     * Height of pop up window
     */
    height: number;
    /**
     * The position of pop up window
     */
    positionWindowPosition: PopupWindowPosition;
}
/**
 * The position of pop up window
 */
export declare enum PopupWindowPosition {
    /**
     * PopupWindowPosition would be located in center of screen
     */
    center = 0,
    /**
     * PopupWindowPosition would be located in right top of screen
     */
    rightTop = 1,
    /**
     * PopupWindowPosition would be located in left top of screen
     */
    leftTop = 2,
    /**
     * PopupWindowPosition would be located in right bottom of screen
     */
    rightBottom = 3,
    /**
     * PopupWindowPosition would be located in left bottom of screen
     */
    leftBottom = 4,
}
