import * as React from 'react';
import './PropertiesTable.scss';
export interface IProperty {
    name: string;
    propertyName: string;
    propertyType: PropertyType;
    property: IInterfaceProperty[] | IEnumProperty[];
}
export interface IInterfaceProperty {
    name: string;
    type: string;
    defaultValue?: string;
    description: string;
}
export interface IEnumProperty {
    name: string;
    description: string;
}
export interface IPropertiesTableProps {
    title?: string;
    properties: IInterfaceProperty[] | IEnumProperty[];
    renderAsEnum?: boolean;
    key?: string;
}
export declare enum PropertyType {
    enum = 0,
    interface = 1,
}
export declare class PropertiesTable extends React.Component<IPropertiesTableProps, any> {
    static defaultProps: {
        title: string;
    };
    constructor(props: IPropertiesTableProps);
    render(): JSX.Element;
}
