"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var React = require('react');
var index_1 = require('../../components/index');
var Layer_Basic_Example_1 = require('./examples/Layer.Basic.Example');
var Layer_Interactive_Example_1 = require('./examples/Layer.Interactive.Example');
var LayerBasicExampleCode = require('./examples/Layer.Basic.Example.tsx');
var LayerInteractiveExampleCode = require('./examples/Layer.Interactive.Example.tsx');
var LayerPage = (function (_super) {
    __extends(LayerPage, _super);
    function LayerPage() {
        _super.apply(this, arguments);
    }
    LayerPage.prototype.render = function () {
        return (React.createElement("div", null, React.createElement("h1", {className: 'ms-font-xxl'}, "Layer"), React.createElement("div", null, React.createElement("p", null, "Layers are used to render content outside of a DOM tree, at the end of the document. This allows content to escape traditional boundaries caused by \"overflow: hidden\" css rules and keeps it on the top without using z-index rules. This is useful for example in ContextualMenu and Tooltip scenarios, where the content should always overlay everything else."), React.createElement("p", null, "There are some special considerations. Due to the nature of rendering content elsewhere asynchronously, React refs within content will not be resolvable synchronously at the time the Layer is mounted. Therefore, to use refs correctly, use functional refs ( ref={ (el) => { this._root = el; } ) rather than string refs ( ref='root' ). Additionally measuring the physical Layer element will not include any of the children, since it won't render it. Events that propgate from within the content will not go through the Layer element as well.")), React.createElement("h2", {className: 'ms-font-xl'}, "Examples"), React.createElement(index_1.ExampleCard, {title: 'Basic', code: LayerBasicExampleCode}, React.createElement(Layer_Basic_Example_1.LayerBasicExample, null)), React.createElement(index_1.ExampleCard, {title: 'Interactive', code: LayerInteractiveExampleCode}, React.createElement(Layer_Interactive_Example_1.LayerInteractiveExample, null)), React.createElement(index_1.PropertiesTableSet, {componentName: 'Layer'})));
    };
    return LayerPage;
}(React.Component));
exports.LayerPage = LayerPage;

//# sourceMappingURL=LayerPage.js.map
