define([], function() { return "import * as React from 'react';\n\nexport interface IButtonProps extends React.HTMLProps<HTMLElement> {\n  /**\n   * The type of the element to render.\n   * @default ElementType.anchor\n   */\n  elementType?: ElementType;\n\n  /**\n   * The type of button to render.\n   * @defaultvalue ButtonType.normal\n   */\n  buttonType?: ButtonType;\n\n  /**\n   * The button icon shown in command or hero type.\n   */\n  icon?: string;\n\n  /**\n   * Description of the action this button takes.\n   * Only used for compound buttons\n   */\n  description?: string;\n\n  /**\n   * Whether the button is disabled\n   */\n  disabled?: boolean;\n\n  /**\n   * The aria label of the button for the benefit of screen readers.\n   */\n  ariaLabel?: string;\n\n  /**\n   * Detailed description of the button for the benefit of screen readers.\n   *\n   * Besides the compound button, other button types will need more information provided to screen reader.\n   */\n  ariaDescription?: string;\n}\n\nexport enum ElementType {\n  /** <button> element */\n  button,\n  /** <a> element */\n  anchor\n}\n\nexport enum ButtonType {\n  normal,\n  primary,\n  hero,\n  compound,\n  command,\n  icon\n}\n"; });