define([], function() { return "export interface IDropdownProps {\r\n  /**\r\n   * Descriptive label for the Dropdown\r\n   */\r\n  label: string;\r\n\r\n  /**\r\n  * Id of the drop down\r\n  */\r\n  id?: string;\r\n\r\n  /**\r\n   * The key of the initially selected option\r\n   */\r\n  selectedKey?: string | number;\r\n\r\n  /**\r\n   * Collection of options for this Dropdown\r\n   */\r\n  options?: IDropdownOption[];\r\n\r\n  /**\r\n   * Callback issues when the selected option changes\r\n   */\r\n  onChanged?: (option: IDropdownOption, index?: number) => void;\r\n\r\n  /**\r\n   * Whether or not the Dropdown is disabled.\r\n   */\r\n  isDisabled?: boolean;\r\n}\r\n\r\nexport interface IDropdownOption {\r\n  /**\r\n   * Arbitrary string associated with this option.\r\n   */\r\n  key: string | number;\r\n\r\n  /**\r\n   * Text to render for this option\r\n   */\r\n  text: string;\r\n\r\n  /**\r\n   * Index for this option\r\n   */\r\n  index?: number;\r\n\r\n  /**\r\n   * Whether this option is currently selected.\r\n   */\r\n  isSelected?: boolean;\r\n}\r\n"; });