define([], function() { return "import * as React from 'react';\nimport { Facepile } from './Facepile';\nimport { PersonaInitialsColor } from '../Persona/index';\n\nexport interface IFacepileProps extends React.Props<Facepile> {\n  /**\n   * Array of IPersonaProps that define each Persona. Note that the size\n   * is fixed at PersonaSize.extraSmall regardless of what is specified.\n   */\n  personas: IFacepilePersona[];\n}\n\nexport interface IFacepilePersona {\n  /**\n   * Name of the person.\n   */\n  personaName?: string;\n\n  /**\n   * Url to the image to use, should be a square aspect ratio and big enough to fit in the image area.\n   */\n  imageUrl?: string;\n\n  /**\n   * The user's initials to display in the image area when there is no image.\n   */\n  imageInitials?: string;\n\n  /**\n   * The background color when the user's initials are displayed.\n   * @defaultvalue PersonaInitialsColor.blue\n   */\n  initialsColor?: PersonaInitialsColor;\n\n  /**\n   * If provided, persona will be rendered with cursor:pointer and the handler will be\n   * called on click.\n   */\n  onClick?: (persona: IFacepilePersona, ev: React.MouseEvent) => void;\n\n  /**\n   * If provided, the handler will be called on mouse move.\n   */\n  onMouseMove?: (persona: IFacepilePersona, ev: React.MouseEvent) => void;\n\n  /**\n   * If provided, the handler will be called when mouse moves out of the component.\n   */\n  onMouseOut?: (persona: IFacepilePersona, ev: React.MouseEvent) => void;\n\n  /**\n   * Extra data - not used directly but can be handy for passing additional data to custom event\n   * handlers.\n   */\n  data?: any;\n}\n"; });