define([], function() { return "import * as React from 'react';\n\nexport interface IFocusTrapZone {\n  /**\n  * Sets focus on the first focusable child in focus trap zone\n  */\n  focus: () => void;\n}\n\nexport interface IFocusTrapZoneProps extends React.HTMLProps<HTMLDivElement> {\n  /**\n   * Sets the HTMLElement to focus on when exiting the FocusTrapZone.\n   * @default The element.target that triggered the FTZ.\n   */\n  elementToFocusOnDismiss?: HTMLElement;\n\n  /**\n   * Sets the aria-labelledby attribute.\n   */\n  ariaLabelledBy?: string;\n\n  /**\n   * Indicates if this Trap Zone will allow clicks outside the FocusTrapZone\n   * @default false\n   */\n  isClickableOutsideFocusTrap?: boolean;\n\n  /**\n   * Indicates if this Trap Zone will ignore keeping track of HTMLElement that activated the Zone.\n   * @default false\n   */\n  ignoreExternalFocusing?: boolean;\n\n   /**\n   * Indicates whether focus trap zone should force focus inside the focus trap zone\n   * @default true\n   */\n  forceFocusInsideTrap?: boolean;\n\n   /**\n   * Indicates the selector for first focusable item\n   */\n  firstFocusableSelector?: string;\n}\n"; });