define([], function() { return "/* tslint:disable:no-unused-variable */\nimport * as React from 'react';\n/* tslint:enable:no-unused-variable */\n\nexport interface ILinkProps extends React.HTMLProps<HTMLLabelElement> {\n  /**\n   *  The props of pop up window.\n   */\n  popupWindowProps?: IPopupWindowProps;\n}\n\nexport interface IPopupWindowProps {\n  /**\n   * Title of pop up window\n   */\n  title: string;\n\n  /**\n   * Width of pop up window\n   */\n  width: number;\n\n  /**\n   * Height of pop up window\n   */\n\n  height: number;\n\n  /**\n   * The position of pop up window\n   */\n  positionWindowPosition: PopupWindowPosition;\n}\n\n/**\n * The position of pop up window\n */\nexport enum PopupWindowPosition {\n  /**\n   * PopupWindowPosition would be located in center of screen\n   */\n  center,\n\n  /**\n   * PopupWindowPosition would be located in right top of screen\n   */\n  rightTop,\n\n  /**\n   * PopupWindowPosition would be located in left top of screen\n   */\n  leftTop,\n\n  /**\n   * PopupWindowPosition would be located in right bottom of screen\n   */\n  rightBottom,\n\n  /**\n   * PopupWindowPosition would be located in left bottom of screen\n   */\n  leftBottom\n}\n\n"; });