define([], function() { return "import * as React from 'react';\n\nexport interface IMessageBarProps extends React.HTMLProps<HTMLElement> {\n\n  /**\n   * The type of MessageBar to render.\n   * @defaultvalue MessageBarType.info\n   */\n  messageBarType?: MessageBarType;\n\n  /**\n   * The actions you want to show on the other side.\n   */\n  actions?: JSX.Element;\n\n  /**\n   * A description of the message bar for the benefit of screen readers.\n   */\n  ariaLabel?: string;\n\n  /**\n   * Whether the message bar has a dismiss button and its callback.\n   * If null, we don't show a dismiss button.\n   * @defaultvalue null\n   */\n  onDismiss?: (ev?: React.MouseEvent) => any;\n\n  /**\n   * Determines if the message bar is multi lined.\n   * If false, and the text overflows over buttons or to another line, it is clipped.\n   * @defaultvalue true\n   */\n  isMultiline?: boolean;\n\n   /**\n   * Aria label on dismiss button if onDismiss is defined.\n   */\n  dismissButtonAriaLabel?: string;\n}\n\nexport enum MessageBarType {\n  /** Info styled MessageBar */\n  info,\n  /** Error styled MessageBar */\n  error,\n  /** Remove styled MessageBar */\n  remove,\n  /** SevereWarning styled MessageBar */\n  severeWarning,\n  /** Success styled MessageBar */\n  success,\n  /** Warning styled MessageBar */\n  warning\n}\n"; });