define([], function() { return "import * as React from 'react';\nimport {\n  Button,\n  ButtonType,\n  ElementType,\n  Label,\n  Checkbox\n} from '../../../../index';\nimport './Button.Basic.Example.scss';\n\nexport interface IBasicButtonsExampleState {\n  disabled: boolean;\n}\n\nexport class ButtonBasicExample extends React.Component<any, IBasicButtonsExampleState> {\n\n  public constructor() {\n    super();\n\n    this._onDisabledChanged = this._onDisabledChanged.bind(this);\n\n    this.state = {\n      disabled: false\n    };\n  }\n\n  public render() {\n    let { disabled } = this.state;\n\n    return (\n      <div className='ms-BasicButtonsExample'>\n        <Label>Normal button</Label>\n        <Button disabled={ disabled }>Create account</Button>\n\n        <Label>Primary button</Label>\n        <Button disabled={ disabled } buttonType={ ButtonType.primary }>Create account</Button>\n\n        <Label>Hero button</Label>\n        <Button disabled={ disabled } buttonType={ ButtonType.hero }>Create account</Button>\n\n        <Label>Compound button</Label>\n        <Button disabled={ disabled } buttonType={ ButtonType.compound } description='You can create a new account here.'>Create account</Button>\n\n        <Label>Command button</Label>\n        <Button disabled={ disabled } buttonType={ ButtonType.command } icon='personAdd' description='Description of the action this button takes'>Create account</Button>\n\n        <Label>Icon button</Label>\n        <Button disabled={ disabled } buttonType={ ButtonType.icon } icon='star' title='Star' ariaLabel='Take a star' />\n\n        <Label>Button like anchor</Label>\n        <Button disabled={ disabled } elementType={ ElementType.anchor } buttonType={ ButtonType.primary } href='http://bing.com' target='_blank' title='Let us bing!' description='Navigate to Bing home page.'>Bing</Button>\n\n        <Label>Button with aria description for screen reader</Label>\n        <Button disabled={ disabled } buttonType={ ButtonType.primary } ariaDescription='This is aria description used for screen reader.'>Aria Description</Button>\n\n        <Checkbox text='Disable buttons' isChecked={ disabled } onChanged={ this._onDisabledChanged } />\n      </div>\n    );\n  }\n\n  private _onDisabledChanged(isDisabled: boolean) {\n    this.setState({\n      disabled: isDisabled\n    });\n  }\n}\n"; });