module.exports = "/* tslint:disable:no-unused-variable */\nimport * as React from 'react';\n/* tslint:enable:no-unused-variable */\nimport { Breadcrumb } from './Breadcrumb';\n\nexport interface IBreadcrumbProps extends React.Props<Breadcrumb> {\n\n  /**\n   * Collection of breadcrumbs to render\n   */\n  items: IBreadcrumbItem[];\n\n  /**\n   * Optional root classname for the root breadcrumb element.\n   */\n  className?: string;\n\n  /**\n   * The maximum number of breadcrumbs to display before coalescing.\n   * If not specified, all breadcrumbs will be rendered.\n   */\n  maxDisplayedItems?: number;\n}\n\nexport interface IBreadcrumbItem {\n\n  /**\n   * Text to display to the user for the breadcrumb\n   */\n  text: string;\n\n  /**\n   * Arbitrary unique string associated with the breadcrumb\n   */\n  key: string;\n\n  /**\n   * Callback issued when the breadcrumb is selected.\n   */\n  onClick?: (key?: string) => void;\n\n  /**\n   * Url to navigate to when this breadcrumb is clicked.\n   */\n  href?: string;\n}";