module.exports = "import * as React from 'react';\nimport { Callout } from './Callout';\nimport { DirectionalHint } from '../../common/DirectionalHint';\nimport { IPositionProps } from '../../utilities/positioning';\n\nexport interface ICalloutProps extends React.Props<Callout>, IPositionProps {\n  /**\n   * Element to anchor the callout to.\n   */\n  targetElement?: HTMLElement;\n\n  /**\n   * Indicator of how the callout should be anchored to its targetElement.\n   * @default DirectionalHint.rightCenter\n   */\n  directionalHint?: DirectionalHint;\n\n  /**\n   * The gap space between the target element and the callout.\n   * @default 20\n   */\n  gapSpace?: number;\n\n  /**\n   * The css className for the beak.\n   * @default 'ms-Callout-beak'\n   */\n  beakStyle?: string;\n\n  /**\n   * The beak width of the selected beakStyle.\n   * @default 28\n   */\n  beakWidth?: number;\n\n  /**\n   * Whether the beak should be visible.\n   * @default true\n   */\n  isBeakVisible?: boolean;\n\n  /**\n   * CSS class to apply to the callout.\n   * @default null\n   */\n  className?: string;\n\n  /**\n   * Optional callback when the layer content has mounted.\n   */\n  onLayerMounted?: () => void;\n\n  /**\n   * Callback when the Callout tries to close.\n   */\n  onDismiss?: (ev?: any) => void;\n\n  /**\n   * If true do not render on a new layer. If false render on a new layer.\n   */\n  doNotLayer?: boolean;\n}\n\nexport interface ILink {\n  /**\n   * Text to render for the link.\n   */\n  name: string;\n\n  /**\n   * URL for the link.\n   */\n  url: string;\n}\n\n";