module.exports = "import * as React from 'react';\n\nexport interface IChoiceGroupProps extends React.HTMLProps<HTMLElement> {\n  /**\n   * The options for the choice group.\n   */\n  options: IChoiceGroupOption[];\n\n  /**\n   * A callback for receiving a notification when the choice has been changed.\n   */\n  onChanged?: (option: IChoiceGroupOption, evt?: React.SyntheticEvent) => void;\n\n  /**\n   * Descriptive label for the choice group.\n   */\n  label?: string;\n}\n\nexport interface IChoiceGroupOption {\n  /**\n   * A required key to uniquely identify the option.\n   */\n  key: string;\n\n  /**\n   * The text string for the option.\n   */\n  text: string;\n\n  /**\n   * The src of image for choice field.\n   */\n  imageSrc?: string;\n\n  /**\n   * The src of image for choice field which is selected.\n   */\n  selectedImageSrc?: string;\n\n  /**\n   * The width and height of the image in px for choice field.\n   */\n  imageSize?: { width: number, height: number };\n\n  /**\n   * Whether the option is disabled or not.\n   * @defaultvalue false\n   */\n  isDisabled?: boolean;\n\n  /**\n   * Whether the options is checked or not.\n   * @defaultvalue false\n   */\n  isChecked?: boolean;\n}\n";