module.exports = "import * as React from 'react';\nimport { Persona } from './Persona';\n\nexport interface IPersonaProps extends React.HTMLProps<Persona> {\n  /**\n   * Primary text to display, usually the name of the person.\n   */\n  primaryText?: string;\n\n  /**\n   * Decides the size of the control.\n   * @defaultvalue PersonaSize.regular\n   */\n  size?: PersonaSize;\n\n  /**\n   * Url to the image to use, should be a square aspect ratio and big enough to fit in the image area.\n   */\n  imageUrl?: string;\n\n  /**\n   * The user's initials to display in the image area when there is no image.\n   */\n  imageInitials?: string;\n\n  /**\n   * The background color when the user's initials are displayed.\n   * @defaultvalue PersonaInitialsColor.blue\n   */\n  initialsColor?: PersonaInitialsColor;\n\n  /**\n   * Presence of the person to display - will not display presence if undefined.\n   * @defaultvalue PersonaPresence.none\n   */\n  presence?: PersonaPresence;\n\n  /**\n   * Secondary text to display, usually the role of the user.\n   */\n  secondaryText?: string;\n\n  /**\n   * Tertiary text to display, usually the status of the user.\n   */\n  tertiaryText?: string;\n\n  /**\n   * Optional text to display, usually a custom message set.\n   */\n  optionalText?: string;\n\n  /**\n   * Whether to not render persona details, and just render the persona image/initials.\n   */\n  hidePersonaDetails?: boolean;\n\n  /**\n   * Additional CSS class(es) to apply to the Persona\n   */\n  className?: string;\n}\n\nexport enum PersonaSize {\n  tiny,\n  extraSmall,\n  small,\n  regular,\n  large,\n  extraLarge\n}\n\nexport enum PersonaPresence {\n  none,\n  offline,\n  online,\n  away,\n  dnd,\n  blocked\n}\n\nexport enum PersonaInitialsColor {\n  lightBlue,\n  blue,\n  darkBlue,\n  teal,\n  lightGreen,\n  green,\n  darkGreen,\n  lightPink,\n  pink,\n  magenta,\n  purple,\n  black,\n  orange,\n  red,\n  darkRed\n}";