module.exports = "import * as React from 'react';\n\nimport { Pivot } from './Pivot';\nimport { PivotItem } from './PivotItem';\n\nexport interface IPivotProps extends React.Props<Pivot> {\n  /**\n   * The index of the pivot item initially selected.\n   *\n   * It only works when initialSelectedKey is not defined. You must not use them together.\n   */\n  initialSelectedIndex?: number;\n\n  /**\n   * The key of the pivot item initially selected.\n   *\n   * It will make initialSelectedIndex not work. You must not use them together.\n   */\n  initialSelectedKey?: string;\n\n  /**\n   * Callback issued when the selected pivot item is changed\n   */\n  onLinkClick?: (item?: PivotItem, ev?: React.MouseEvent) => void;\n\n  /**\n   * Specify the PivotLinkSize to use (normal, large)\n   */\n  linkSize?: PivotLinkSize;\n\n  /**\n   * Specify the PivotLinkFormat to use (links, tabs)\n   */\n  linkFormat?: PivotLinkFormat;\n\n}\n\nexport enum PivotLinkFormat {\n  /**\n   * Display Pivot Links as links\n   */\n  links,\n\n  /**\n   * Display Pivot Links as Tabs\n   */\n  tabs\n}\n\nexport enum PivotLinkSize {\n\n  /**\n   * Display Link using normal font size\n   */\n  normal,\n\n  /**\n   * Display links using large font size\n   */\n  large\n}";