module.exports = "import * as React from 'react';\n\nexport interface IPivotItemProps extends React.HTMLProps<HTMLDivElement> {\n  /**\n   * The text displayed of each pivot link.\n   */\n  linkText: string;\n\n  /**\n   * An required key to uniquely identify a pivot item.\n   *\n   * Note: The 'key' from react props cannot be used inside component.\n   */\n  itemKey?: string;\n\n  /**\n   * The aria label of each pivot link which will read by screen reader instead of linkText.\n   *\n   * Note that unless you have compelling requirements you should not override aria-label.\n   */\n  ariaLabel?: string;\n}";