module.exports = "export interface ISliderProps {\n  /**\n   * Description label of the Slider\n   */\n  label?: string;\n\n  /**\n   * The initial value of the Slider. Use this if you intend for the Slider to be an uncontrolled component.\n   * This value is mutually exclusive to value. Use one or the other.\n   */\n  defaultValue?: number;\n\n  /**\n   * The initial value of the Slider. Use this if you intend to pass in a new value as a result of onChange events.\n   * This value is mutually exclusive to defaultValue. Use one or the other.\n   */\n  value?: number;\n\n  /**\n   * The min value of the Slider\n   * @default 0\n   */\n  min?: number;\n\n  /**\n   * The max value of the Slider\n   * @default 10\n   */\n  max: number;\n\n  /**\n   * The diffrrence between the two adjacent values of the Slider\n   * @default 1\n   */\n  step?: number;\n\n  /**\n   * Whether to show the value on the right of the Slider.\n   * If you want to show the value by yourself, you may want to set this value to false.\n   */\n  showValue?: boolean;\n\n  /**\n   * Callback when the value has been changed\n   */\n  onChange?: (value: number) => void;\n\n  /**\n   * A description of the Slider for the benefit of screen readers.\n   */\n  ariaLabel?: string;\n\n  /**\n   * Whether or not the Slider is disabled.\n   */\n  disabled?: boolean;\n\n  /**\n  * Optional className for slider.\n  */\n  className?: string;\n}\n\nexport interface ISlider {\n  value: number;\n\n  focus: () => void;\n}\n";