module.exports = "import * as React from 'react';\n\n/**\n * Toggle component props.\n */\nexport interface IToggleProps extends React.HTMLProps<HTMLInputElement> {\n  /**\n   * A label for the toggle.\n   */\n  label: string;\n\n  /**\n   * Text to display when toggle is ON.\n   */\n  onText?: string;\n\n  /**\n   * Test display when toggle is OFF.\n   */\n  offText?: string;\n\n  /**\n   * Checked state of the toggle. If you are maintaining state yourself, use this property. Otherwise refer to 'defaultChecked'.\n   */\n  checked?: boolean;\n\n  /**\n   * Initial state of the toggle. If you want the toggle to maintain its own state, use this. Otherwise refer to 'checked'.\n   */\n  defaultChecked?: boolean;\n\n  /**\n   * Optional disabled flag.\n   */\n  disabled?: boolean;\n\n  /**\n   * onchange callback.\n   */\n  onChanged?: (isChecked: boolean) => void;\n}";